Developer Documentation

Public Slots | Signals | Public Member Functions | Private Types | Private Slots | Private Attributes | List of all members
SmootherPlugin Class Reference

`#include <Plugin-Smoother/SmootherPlugin.hh>`

Inheritance diagram for SmootherPlugin:

## Public Slots
QString | version ()
void | simpleLaplace (int _iterations)
| simpleLaplace More...
QString | version ()
QString | version ()
Scripting Functions
void | smooth (int _objectId, int _iterations, QString _direction, QString _continuity, double _maxDistance=-1.0, bool _respectFeatures=true)
| smooth an object More...

## Signals
void | updateView ()
void | updatedObject (int _identifier, const UpdateType &_type)
void | log (Logtype _type, QString _message)
void | log (QString _message)
void | addToolbox (QString _name, QWidget *_widget)
void | updateView ()
void | updatedObject (int _id, const UpdateType &_type)
void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
void | log (Logtype _type, QString _message)
void | log (QString _message)
void | addToolbox (QString _name, QWidget *_widget, QIcon *_icon)
void | scriptInfo (QString _functionName)
void | createBackup (int _id, QString _name, UpdateType _type=UPDATE_ALL)
void | updateView ()
void | updatedObject (int, const UpdateType &)
void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
void | log (Logtype _type, QString _message)
void | log (QString _message)
void | addToolbox (QString _name, QWidget *_widget, QIcon *_icon)
void | createBackup (int _id, QString _name, UpdateType _type=UPDATE_ALL)
void | scriptInfo (QString _functionName)
Signals inherited from BaseInterface
virtual void | updateView ()
| Update current view in Main Application. More...
virtual void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
| Set a description for a public slot. More...
virtual void | setRenderer (unsigned int _viewer, QString _rendererName)
| Set a renderer for the given viewer. More...
Signals inherited from ToolboxInterface
virtual void | addToolbox (QString _name, QWidget *_widget)
| Add a toolbox widget to the gui with the given name. More...
Signals inherited from LoggingInterface
virtual void | log (Logtype _type, QString _message)=0
virtual void | log (QString _message)=0
Signals inherited from BackupInterface
virtual void | createBackup (int _objectid, QString _name, UpdateType _type=UPDATE_ALL)
| Tell Backup Plugin to create a backup. More...
virtual void | aboutToRestore (int _objectid)
| Backup Plugin tells other Plugins that a restore will happen. More...
virtual void | generateBackup (int _id, QString _name, UpdateType _type)
| This signal is emitted by a BackupPlugin and tells a TypePlugin to generate a backup. More...
Signals inherited from ScriptInterface
virtual void | scriptInfo (QString _functionWithParameters)
| Emit this signal if a scriptable function is executed. More...
virtual void | getScriptingEngine (QScriptEngine *&_engine)
virtual void | executeScript (QString _script)
virtual void | getAvailableFunctions (QStringList &_functions)

## Public Member Functions
QString | name ()
| Return a name for the plugin. More...
QString | description ()
| Return a description of what the plugin is doing. More...
QString | name ()
| Return a name for the plugin. More...
QString | description ()
| Return a description of what the plugin is doing. More...
| SmootherPlugin ()
| default constructor
| ~SmootherPlugin ()
| default destructor
QString | name ()
| Name of the Plugin.
QString | description ()
| Description of the Plugin.

## Private Types
typedef OpenMesh::Smoother::JacobiLaplaceSmootherT< TriMesh > | SmootherType

## Private Slots
void | initializePlugin ()
void | simpleLaplace ()
| simpleLaplace More...
void | simpleLaplace ()
void | initializePlugin ()
void | pluginsInitialized ()
| Set the scripting slot descriptions. More...
void | initializePlugin ()
void | pluginsInitialized ()
| Second initialization stage.
void | noguiSupported ()
| Tell system that this plugin runs without ui.
void | slot_smooth ()
| Slot connected to the smooth button in the toolbox. More...
Private Slots inherited from BaseInterface
virtual void | exit ()
virtual QString | version ()
| Return a version string for your plugin. More...

## Private Attributes
QSpinBox * | iterationsSpinbox_
| SpinBox for Number of iterations.
SmootherToolbarWidget * | tool_
| Widget for Toolbox.
QIcon * | toolIcon_

## Additional Inherited Members
Private Member Functions inherited from BaseInterface
virtual void | noguiSupported ()
virtual | ~BaseInterface ()
| Destructor.
virtual void | blockScenegraphUpdates (bool _block)
| Tell the core to prevent scenegraph updates. More...
virtual void | updatedObject (int _objectId)
| An object has been changed or added by this plugin. More...
virtual void | updatedObject (int _identifier, const UpdateType &_type)
| An object has been changed or added by this plugin. More...
virtual void | nodeVisibilityChanged (int _identifier)
| A scenegraph node has been shown or hidden. More...
virtual void | getCurrentRenderer (unsigned int _viewer, QString &_rendererName)
| Get the current renderer for the given viewer. More...
Private Member Functions inherited from ToolboxInterface
virtual | ~ToolboxInterface ()
| Destructor.
virtual void | addToolbox (QString _name, QWidget *_widget, QIcon *_icon)
| Add a toolbox widget to the gui with the given name and an icon. More...
virtual void | addToolbox (QString _name, QWidget *_widget, QIcon *_icon, QWidget *_headerAreaWidget)
| Add a toolbox widget to the gui with the given name, icon and header area widget. More...
Private Member Functions inherited from LoggingInterface
virtual | ~LoggingInterface ()
| Destructor.
Private Member Functions inherited from BackupInterface
virtual void | createBackup (IdList _objectids, QString _name, std::vector< UpdateType > _types)
| Tell Backup Plugin to create a group backup. More...
virtual void | undo (int _objectid)
| Tell Backup Plugin to undo the last action of an object. More...
virtual void | redo (int _objectid)
| Tell Backup Plugin to redo the last action on an object. More...
virtual void | undo ()
| Tell Backup Plugin to undo the last action. More...
virtual void | redo ()
| Tell Backup Plugin to redo the last action. More...
virtual | ~BackupInterface ()
| Destructor.
virtual void | restored (int _objectid)
| Backup Plugin tells other Plugins that a restore has happened. More...
Private Member Functions inherited from ScriptInterface
virtual | ~ScriptInterface ()
| Destructor.
virtual void | executeFileScript (QString _filename)
virtual void | getDescription (QString _function, QString &_description, QStringList &_parameters, QStringList &_descriptions)
Private Member Functions inherited from PythonInterface
virtual | ~PythonInterface ()
| Destructor.

## Detailed Description

Plugin for Smoother Support

Definition at line 9 of file SmootherPlugin.hh.

## Member Function Documentation

## ◆ description() [1/2]

QString SmootherPlugin::description | ( |  | ) |
| inline virtual

Return a description of what the plugin is doing.

This function has to return a basic description of the plugin

Implements BaseInterface.

Definition at line 34 of file SmootherPlugin.hh.

## ◆ description() [2/2]

QString SmootherPlugin::description | ( |  | ) |
| inline virtual

Return a description of what the plugin is doing.

This function has to return a basic description of the plugin

Implements BaseInterface.

Definition at line 94 of file SmootherPlugin.hh.

## ◆ name() [1/2]

QString SmootherPlugin::name | ( |  | ) |
| inline virtual

Return a name for the plugin.

This Function has to return the name of the plugin.

Implements BaseInterface.

Definition at line 33 of file SmootherPlugin.hh.

## ◆ name() [2/2]

QString SmootherPlugin::name | ( |  | ) |
| inline virtual

Return a name for the plugin.

This Function has to return the name of the plugin.

Implements BaseInterface.

Definition at line 93 of file SmootherPlugin.hh.

## ◆ pluginsInitialized

void SmootherPlugin::pluginsInitialized | ( |  | ) |
| private slot

Set the scripting slot descriptions.

Definition at line 97 of file SmootherPlugin.cc.

## ◆ simpleLaplace [1/2]

void SmootherPlugin::simpleLaplace | ( |  | ) |
| private slot

simpleLaplace

Smooth mesh using the Laplace operator with uniform weights.

Definition at line 75 of file SmootherPlugin.cc.

## ◆ simpleLaplace [2/2]

void SmootherPlugin::simpleLaplace | ( | int | _iterations | ) |
| slot

simpleLaplace

Smooth mesh using the Laplace operator with uniform weights.

Parameters

  _iterations | Number of iterations

Definition at line 127 of file SmootherPlugin.cc.

## ◆ slot_smooth

void SmootherPlugin::slot_smooth | ( |  | ) |
| private slot

Slot connected to the smooth button in the toolbox.

Smooth all target objects.

Parameters for the smoothing are retrieved from the toolbox

Definition at line 120 of file SmootherPlugin.cc.

## ◆ smooth

void SmootherPlugin::smooth | ( | int | _objectId,
|  | int | _iterations,
|  | QString | _direction,
|  | QString | _continuity,
|  | double | _maxDistance = `-1.0`,
|  | bool | _respectFeatures = `true`
| ) |  |
| slot

smooth an object

Parameters

  _objectId | Id of the object that should be smoothed
  _iterations | Number of iterations
  _direction | Tangential or normal?
  _continuity | Continuity selection
  _maxDistance | Maximal distance after smoothing
  _respectFeatures | Keep features

Definition at line 233 of file SmootherPlugin.cc.

The documentation for this class was generated from the following files:

- OpenFlipper/Documentation/DeveloperHelpSources/example/SmootherPlugin.hh
- OpenFlipper/Documentation/DeveloperHelpSources/example/SmootherPlugin.cc